//
//  TSetting.cs
//  Copyright 2005 Takeshi Yoneki / OSTRA / OSTRACISM CO., All rights reserved.
//
using System;
using System.Drawing;
using System.Xml.Serialization;
using System.IO;

namespace GGG4W
{
	/// <summary>
	/// TSetteing ݒۑNX
	/// </summary>
	public class TSetting
	{
		const int CURRENT_PREF_VERSION = 0x100;

		public int version = CURRENT_PREF_VERSION;
		public Point location;
		public int windowHeight;
		public int windowWidth;
		public string targetFilePath;
		public string topDirPath;
		public string indexFilePath;
		public int bits = 3;
		public int matchRate = 70;
		public int pixelNumber = 8;
		public int searchMethod = 0;
		
		public TSetting()
		{
			// 
			// TODO: RXgN^ WbNɒǉĂB
			//
		}

		/// <summary>
		/// f[^̃Rs[
		/// </summary>
		/// <param name="s"></param>
		public void CopyFrom(TSetting s) {
			version = s.version;
			location = s.location;
			windowHeight = s.windowHeight;
			windowWidth = s.windowWidth;
			targetFilePath = s.targetFilePath;
			topDirPath = s.topDirPath;
			indexFilePath = s.indexFilePath;
			bits = s.bits;
			matchRate = s.matchRate;
			pixelNumber = s.pixelNumber;
			searchMethod = s.searchMethod;
		}

		/// <summary>
		/// N[쐬
		/// </summary>
		/// <returns></returns>
		public TSetting Clone() {
			TSetting s = new TSetting();
			s.CopyFrom(this);
			return s;
		}

		/// <summary>
		/// r
		/// </summary>
		/// <param name="s"></param>
		/// <returns></returns>
		public bool Equals(TSetting s) {
			return (
				s.location == location &&
				s.windowHeight == windowHeight &&
				s.windowWidth == windowWidth &&
				s.targetFilePath == targetFilePath &&
				s.topDirPath == topDirPath &&
				s.indexFilePath == indexFilePath &&
				s.bits == bits &&
				s.matchRate == matchRate &&
				s.pixelNumber == pixelNumber &&
				s.searchMethod == searchMethod
			);
		}

		static string GetSettingDirPath() {
			return Path.Combine(System.Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData), "OSTRA");
		}

		static string GetSettingFilePath() {
			return Path.Combine(GetSettingDirPath(), "GGG4W.setting");
		}

		/// <summary>
		/// ݒ̓ǂݍ
		/// </summary>
		/// <returns></returns>
		public bool Beginning() {
			bool result = false;
			TSetting temp = new TSetting();
			XmlSerializer serializer = new XmlSerializer(typeof(TSetting));
			FileStream fs = null;
			try {
				fs = new FileStream(GetSettingFilePath(), FileMode.Open);
			}
			catch {
				fs = null;
			}
			if (fs != null) {
				try {
					temp = (TSetting)serializer.Deserialize(fs);
				}
				catch {
				}
				fs.Close();
				if (temp.version != 0) {
					CopyFrom(temp);
					version = CURRENT_PREF_VERSION;
					result = true;
				}
			}

			return result;
		}

		/// <summary>
		/// ݒ̏o
		/// </summary>
		/// <returns></returns>
		public bool Ending() {
			bool result = false;
			string dir = GetSettingDirPath();
			if (Directory.Exists(dir) == false) {
				Directory.CreateDirectory(dir);
			}
			XmlSerializer serializer = new XmlSerializer(typeof(TSetting));
			FileStream fs = new FileStream(GetSettingFilePath(), FileMode.Create);
			if (fs != null) {
				serializer.Serialize(fs, this);
				fs.Close();
				result = true;
			}
			return result;
		}

	}
}
